#ifndef _FRED_
#define _FRED_ 
#include "array.h"
#include "clause.h"
#include "memory.h"
#include "sharing.h"
#include "term.h"
#include "state.h"
#include "subsume.h"
#include "condense.h"
#include "twfo.h"
#include "trail.h"
#include "abstract.h"
void fred_InsertClauseToIndex(SCLSTATE, CLAUSE);
void fred_RemoveClauseFromIndex(SCLSTATE, CLAUSE);
void fred_ShareClause(SHARER, CLAUSE);
void fred_ExhaustiveForwardSubRes(SCLSTATE, CLAUSE, BOOL);
void fred_InitialStateRedundancy(SCLSTATE);
BOOL fred_BackReduction(SCLSTATE, TRAIL, TWFO, ARRAY*);
void fred_ExhaustiveBackwardSubRes(SCLSTATE, CLAUSE, BOOL, ARRAY*, ARRAY*);
#endif
